'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fancyMatch = require('fancymatch');

var Permissions = function () {
    function Permissions(permissions) {
        _classCallCheck(this, Permissions);

        this.permissions = permissions;
    }

    _createClass(Permissions, [{
        key: 'match',
        value: function match(permission) {
            // create matcher and then match permission tree against it
            var matcher = new fancyMatch(permission);
            return Permissions.checkGroup(this.permissions, matcher);
        }
    }], [{
        key: 'checkGroup',
        value: function checkGroup(group, permission) {
            var allowed = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

            //check if inheriting the permission from a group and if they allow it
            if (group.inherit) {
                var allowed = group.inherit.reduce(function (allowed, group) {
                    return Permissions.checkGroup(group, permission, allowed);
                }, allowed);
            }
            //check if allowed permission
            allowed = group.allowed.reduce(function (allowed, item) {
                if (permission.match(item)) {
                    return true;
                } else {
                    return allowed;
                }
            }, allowed);
            //check if disallowed permission
            allowed = group.disallowed.reduce(function (allowed, item) {
                if (permission.match(item)) {
                    return false;
                } else {
                    return allowed;
                }
            }, allowed);
            return allowed;
        }
    }]);

    return Permissions;
}();

module.exports = Permissions;