'use strict';

var Permissions = require('./Permissions');
module.exports = function (database) {
    //function to resurively build permissions tree
    function processGroup(group) {
        var groups = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

        //set permissions for current group
        var permmissions = {
            allowed: group.allowed || [],
            disallowed: group.disallowed || []
            //check if group inherits
        };if (group.inherit) {
            //if inherit add sub group permission onto tree (resurively) and return
            return Promise.all(group.inherit.map(function (group) {
                return database.getGroup(group).then(function (group) {
                    return processGroup(group);
                });
            })).then(function (groups) {
                permmissions.inherit = groups;
                return permmissions;
            });
        } else {
            //if not return current Permissions object (end of branch)
            return Promise.resolve(permmissions);
        }
    }
    return function (user) {
        //create the permissions tree then create new object from tree
        return processGroup(user).then(function (permissions) {
            return new Permissions(permissions);
        });
    };
};