'use strict';

var fancyMatch = require('fancymatch');
var Handlebars = require('handlebars');
var DefaultExtracter = function DefaultExtracter(req) {
    if (req.user && req.user.Permissions) {
        return req.user.Permissions;
    } else {
        return {};
    }
};
module.exports = function need(permission) {
    var permissionTemplate = Handlebars.compile(permission);
    return function (req, res, next) {
        var extracter = req.FancyPermissionsExtracter || DefaultExtracter;
        var permissionsString = permissionTemplate({ req: req, res: res });
        if (extracter(req).match(permissionsString)) {
            return next();
        }
        throw "permission deined";
    };
};